#! /bin/sh
change_file_context() {
file=$1
if [ -f /usr/sbin/semanage ]; then 
	semanage fcontext -a -t uld_exec_t $file  2>&1 | log_message
	restorecon -v $file  2>&1 | log_message
else
	chcon -t uld_exec_t $file 2>&1 | log_message
fi 
return 0
}
set_selinux_policy() {

SELINUX_SCRIPT_DIR=.
SELINUX_TEMP_DIR=/tmp/selinux_uld_policy
SELINUX_MAKEFILE=/usr/share/selinux/devel/Makefile

log_message "Set SELinux policy:"

if  ! test -d $SELINUX_TEMP_DIR ; then
	mkdir $SELINUX_TEMP_DIR
fi

install $SELINUX_SCRIPT_DIR/uld_policy.te $SELINUX_TEMP_DIR

if [ -f $SELINUX_MAKEFILE ]; then
	( cd $SELINUX_TEMP_DIR &&
	make -f $SELINUX_MAKEFILE 2>&1 | log_message )
else
	return 1
fi

if [ -f $SELINUX_TEMP_DIR/uld_policy.pp ]; then
	if ( semodule -l | grep uld_policy &> /dev/null ); then
	        semodule -u $SELINUX_TEMP_DIR/uld_policy.pp  2>&1 | log_message
	else
		semodule -i $SELINUX_TEMP_DIR/uld_policy.pp  2>&1 | log_message
	fi
else
    	return 1
fi

change_file_context $1

return 0
}

remove_selinux_policy() {
log_message "Remove SELinux policy"

file_list=$(semanage fcontext -l | grep uld | grep -o /usr/lib.*/cups/backend/mfp )
for i in $file_list; do
	if [ -f /usr/sbin/semanage ]; then 
		semanage fcontext -d $i 2>&1 | log_message
	fi	
	restorecon -v $i 2>&1 | log_message
done

semodule -r uld_policy  2>&1 | log_message

return 0

}
